; ************************************************************************************************
; * DMX zu WS2801/TM1804 fr SEDU-Board														 	 *
; * Konfigurationen																	 			 *
; ************************************************************************************************

; ================================================================================================
; Ports I/O setzen etc.
; ------------------------------------------------------------------------------------------------

		ldi		temp0, (1<<Pix_SDO) | (1<<Pix_SCO)	; Pixel-Ports auf Ausgang
		out		Pix_DDR, temp0

		sbi		S_LED_DDR, S_LED				; Port fr Status-LED auf Ausgang

		sbi		RS485DIR_DDR, RS485DIR			; Port fr RS485-Bustreiber-Richtung auf Ausgang

		in		temp0, DDRA						; Pullups an allen Eingngen
		com		temp0
		out		PortA, temp0

		in		temp0, DDRB						; Pullups an allen Eingngen
		com		temp0
		out		PortB, temp0

		in		temp0, DDRC						; Pullups an allen Eingngen
		com		temp0
		out		PortC, temp0

		in		temp0, DDRD						; Pullups an allen Eingngen
		com		temp0
		out		PortD, temp0

; ================================================================================================
; Stackpointer setzen
; ------------------------------------------------------------------------------------------------

		ldi 	temp0, HIGH(RAMEND)				; HIGH-Byte der obersten RAM-Adresse
		out 	SPH, temp0						; in den Stackpointer
		ldi 	temp0, LOW(RAMEND)				; LOW-Byte der obersten RAM-Adresse
		out 	SPL, temp0						; in den Stackpointer

; ================================================================================================
; USART1 konfigurieren fr DMX
; ------------------------------------------------------------------------------------------------

.equ UBRR_DMX =((XTAL+BAUD_DMX*8)/(BAUD_DMX*16)-1)  	; UBBR ausrechnen

	   	ldi 	temp0, UBRR_DMX			 		; Usart auf Baudrate DMX setzen
    	sts 	UBRR1L, temp0
    	clr 	temp0
    	sts 	UBRR1H, temp0

    	ldi 	temp0, (3<<UCSZ10)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR1C, temp0			

		ldi		temp0, (1<<RXEN1)|(1<<RXCIE1) 	; Rx, RxComplInt. enable
		sts		UCSR1B, temp0

		clr		DMX_state						; Start-Status: auf Frame Error warten

		cbi		RS485DIR_PORT, RS485DIR			; Bustreiber auf Empfangen

; ================================================================================================
; DMX-Startadresse setzen
; ------------------------------------------------------------------------------------------------

		ldi		temp0, high(DMX_Adress)
		mov		DMX_Base_H, temp0
		ldi		temp0, low(DMX_Adress)
		mov		DMX_Base_L, temp0

; ================================================================================================
; Farbreihenfolge setzen
; ------------------------------------------------------------------------------------------------

		ldi		temp0, RGB_change
		sts		RGB_Order, temp0

; ================================================================================================
; Div. Grundeinstellungen
; ------------------------------------------------------------------------------------------------

		clr		Flags							; Alle Flags lschen
		sbr		Flags, (1<<FL_DMX_FR)			; test-Ausgabe

; ================================================================================================
; DMX-Empfangspuffer lschen
; ------------------------------------------------------------------------------------------------

		ldi		temp0, Pix_Count

		ldi		ZL, low(DMX_DATA)
		ldi		ZH, high(DMX_DATA)

_clr_dmx_buffer:

		ldi		temp1, SU_R
		st		Z+, temp1
		ldi		temp1, SU_G
		st		Z+, temp1
		ldi		temp1, SU_B
		st		Z+, temp1

		dec		temp0
		brne	_clr_dmx_buffer

; ================================================================================================

		sei										; Interrupts aktivieren

; ================================================================================================

