; ************************************************************************************************
; * DMX zu WS2801-Umsetzung fr SEDU-Board	mit M644p										 	 *
; *																								 *
; *	empfngt bis 510 Kanle ber DMX und gibt sie an WS2801/TM1804 aus							 *
; *	mit Mglichkeit, die Farben umzusortieren													 *
; *	bei fehlendem DMX-Empfang laufen div.Standalone-Programme (folgt)							 *
; *	Konfiguration erfolgt momentan fest eingebrannt, spter ber DIP							 *
; *																								 *
; *	by Pesi	- Version 0.1 - 08.03.2012															 *
; ************************************************************************************************

.include "m644Pdef.inc"							; verwendeter C: Mega644p

.include "Definitions.inc"						; Definitionen Register, Konstanten etc.

.CSEG

.include "Interrupts.inc"						; IRQ-Vektor-Tabelle

; ================================================================================================
; Subroutinen
; ------------------------------------------------------------------------------------------------

.include "ISR_Byte_Received.inc"				; DMX-Empfangsroutine

.include "SUB_Data_Shiftout.inc"				; Bitbang-Ausgaberoutine fr WS2801/TM1804

; ================================================================================================

Start:

.include "Configuration.inc"					; Ports setzen, Timer konfigurieren etc.

; ================================================================================================
; Hauptschleife
;
; Daten werden in ISR per DMX empfangen, bei komplettem Frame an die Pixel ausgegeben
; da die Ausgabe wesentlich schneller erfolgt als das empfangen eines Frames ber DMX
; entsteht so die 500 s-Pause fr die WS2801 "automatisch"
;
; schickt der DMX-Sender deutlich weniger Kanle als 512 raus (z.B. kleines Lichtpult o..)
; muss die Pixel-Anzahl zur Ausgabe auch verringert werden, da sonst die Ausgabe lnger dauert
; als das empfangen, und somit die Pause fr die Datenbernahme wegfllt
; ------------------------------------------------------------------------------------------------

Main:

		sbrs	Flags, FL_DMX_FR				; Neuer Frame empfangen?
		rjmp	Main							; Nein, Hauptschleife von vorne
		cbr		Flags, (1<<FL_DMX_FR)			; ja, Flag wieder lschen

		rcall	SUB_Data_Shiftout				; und Daten ausgeben

		rjmp	Main							; Hauptschleife von vorne

; ================================================================================================
