; ================================================================================================
; DMX zu WS2801/TM1804-Umsetzung fr SEDU-Board
; Definitionen Register, Konstanten, etc.
; ================================================================================================

; *** Einstellungen ***

.equ DMX_Adress			= 1				; DMX-Startadresse
.equ DMX_Channels		= 510			; Anzahl zu empfangender Kanle

.equ RGB_Change			= 0				; Farben tauschen
										; 0 = nicht tauschen
										; 1 = tauschen RGB -> GRB
										; 2 = tauschen RGB -> RBG
										; 3 = tauschen RGB -> BGR
										; 4 = tauschen RGB -> BRG
										; 5 = tauschen RGB -> GBR

.equ Pix_Count			= 170			; RGB-Pixel-Anzahl

.equ SU_R				= 0				; Start-Farbe Rot
.equ SU_G				= 0				; Start-Farbe Grn
.equ SU_B				= 255			; Start-Farbe Blau

.equ Pix_Port 			= PortC			; Ausgabeport WS2801/TM1804-Daten
.equ Pix_DDR 			= DDRC			; DDR WS2801/TM1804-Daten
.equ Pix_SDO			= 0				; Ausgabepin WS2801/TM1804 Data
.equ Pix_SCO			= 1				; Ausgabepin WS2801 Clock

; ================================================================================================
; Register definieren
; ------------------------------------------------------------------------------------------------

.def temp0 				= R16			; Mehrzweck-Temp-Register	
.def temp1 				= R17
.def temp2 				= R18
.def temp3				= R19
.def temp4				= R20

.def DMX_state			= R21			; DMX-Status, Register muss >15 sein
.def DMX_L				= R2			; Low-Byte DMX-Adress-Pointer
.def DMX_H				= R3			; High-Byte DMX-Adress-Pointer
.def DMX_Base_L			= R4			; Low-Byte DMX-Startadresse
.def DMX_Base_H			= R6			; High-Byte DMX-Startadresse
.def DMX_Timeout		= R7			; Zhler fr Timeout fehlender Empfang

.def temp_R				= R8			; Temp-Register fr Farbrechnungen
.def temp_G				= R9
.def temp_B				= R10

.def Flags				= R22			; Div. Flags

; ================================================================================================
; Konstanten/Aliase definieren
; ------------------------------------------------------------------------------------------------

.equ XTAL				= 20000000		; Prozessortakt 20 MHz

.equ BAUD_DMX			= 250000		; Baudrate DMX-Empfang

.equ FL_DMX_FR			= 0				; Flag fr DMX-Frame empfangen

.equ S_LED				= 5				; Status-LED
.equ S_LED_PORT			= PortD			; Port Status-LED
.equ S_LED_PIN			= PinD			; Pin Status-LED
.equ S_LED_DDR			= DDRD			; DDR Status-LED

.equ RS485DIR			= 6				; Umschaltung RS485-Bustreiber
.equ RS485DIR_PORT		= PortD			; Port Umschaltung RS485-Bustreiber
.equ RS485DIR_DDR		= DDRD			; DDR Umschaltung RS485-Bustreiber

; ================================================================================================
; RAM-Bereiche definieren
; ------------------------------------------------------------------------------------------------

.dseg

RGB_Order:			.byte 1					; RGB-Reihenfolge

Pix_Outbuffer:;		.byte (Pix_Count * 3)	; RAM-Puffer fr Ausgabedaten

DMX_Data:			.byte DMX_Channels		; RAM-Bereich fr empfangene Daten

; ================================================================================================

