; ================================================================================================
; ISR fr DMX-Empfang
; ------------------------------------------------------------------------------------------------

ISR_Byte_Received_U1:

		push	temp1							; Register sichern
		in      temp1, SREG
		push	temp1
		push	temp0		
		push	ZH
		push 	ZL
		mov		ZL, DMX_L
		mov		ZH, DMX_H

		lds		temp0,UCSR1A					; Status und Daten holen
		lds		temp1,UDR1

		sbrc	temp0,FE1						; Frame-Error: neuer Durchgang
		rjmp	dmx_frame_error	
		
		cpi		DMX_state, 1   					; auf Startbyte testen
		breq	dmx_startbyte

  		cpi 	DMX_state, 2   					; auf Startadresse warten
		breq    dmx_startadr
  		
 		cpi 	DMX_state, 3					; empfangenes Byte speichern
  		brsh	dmx_store_byte

dmx_finish:

		mov		DMX_H, ZH						; Register wieder herstellen
		mov		DMX_L, ZL
		pop		ZL
		pop		ZH
		pop		temp0
		pop		temp1
		out     SREG, temp1	
		pop		temp1
		reti			

dmx_startbyte:

		tst 	temp1	 						; Byte = 0 --> Startbyte, sonst Fehler
		brne 	dmx_err
		inc  	DMX_state

		mov 	ZL, DMX_Base_L 					; Startadresse holen
		mov		ZH, DMX_Base_H

		clr		DMX_Timeout						; Timeout-Zhler resetten

		sbi		S_LED_PIN, S_LED				; Status-LED toggeln
		sbr		Flags, (1<<FL_DMX_FR)			; und Flag setzen fr Frame empfangen

		rjmp	dmx_finish

dmx_startadr:

		sbiw	ZH:ZL, 1						; Adresse runterzhlen
		brne	dmx_finish						; Startadresse noch nicht erreicht

		ldi 	ZH, high(DMX_Data)				; Startadresse erreicht, Pointer setzen
		ldi		ZL, low(DMX_Data)
		inc  	DMX_state
		
dmx_store_byte:
			
		st		Z+, temp1

		cpi		ZL, low(DMX_Data+DMX_Channels)	; empfangene Bytes zhlen
		brne	dmx_finish
		cpi		ZH, high(DMX_Data+DMX_Channels)
		brne	dmx_finish						; noch nicht durch, Ende

		clr		DMX_state						; Alle Bytes empfangen, auf nchsten FE warten

		rjmp	dmx_finish
	
dmx_frame_error:

		ldi 	DMX_state, 1					; Frame-Error --> neuer Durchlauf
		ldi 	temp0, (1<<FE1)				
		sts		UCSR1A, temp0					; Flag lschen, falls lngere Pause
		rjmp	dmx_finish

dmx_err:

	 	clr 	DMX_state						; auf nchsten FE warten			
		rjmp	dmx_finish

; ================================================================================================

